variables:
  GITLAB_TOKEN: ""
  BRANCH_TRIVY: "main"
  TRIVY_IMAGE: "code.europa.eu:4567/simpl/simpl-open/operations/pipelineimages/simpl-trivy:1.0.0" #Special Image, frozen to specific Trivy version that supports *.cdx file generation
  TRIVY_CACHE_PROJECT_ID: "739"

# See https://aquasecurity.github.io/trivy/v0.29.2/docs/references/cli/image/ for trivy CLI syntax
update-trivy-database:
  image: $TRIVY_IMAGE
  # image: bitnami/trivy:0.36.1
  stage: scheduled
  script:
    # Download the Trivy database
    - trivy image --download-db-only
    - pwd
    - ls -la
    # Archive the db directory into a tar file
    - tar -cvf trivy-db.tar /.cache/trivy/db/
  artifacts:
    name: "trivy-db"
    paths:
      - trivy-db.tar
    expire_in: 1 week
  rules:
    - if: $CI_PROJECT_NAME == "pipeline" && $CI_COMMIT_REF_SLUG == "main" # this is neeeded because of the pipeline release in main brakes the artifact availability
    - if: $SCHEDULED_JOB == "update-trivy-database"

get-trivy-database:
  image: $TRIVY_IMAGE
  # image: bitnami/trivy:0.36.1
  stage: scheduled
  script:
    - URL="$CI_API_V4_URL/projects/$TRIVY_CACHE_PROJECT_ID/jobs/artifacts/$BRANCH_TRIVY/download?job=update-trivy-database"
    - echo $URL
    # GitLab job download provideds a .gz file. This is why we happended .gz to tar
    - STATUS_CODE=$(curl -w "%{http_code}" --location --header PRIVATE-TOKEN:$GITLAB_TOKEN $URL -o trivy-db.tar.gz)
    - if [ "$STATUS_CODE" -eq "200" ]; then
    -   echo OK
    # This following logic comes from https://aquasecurity.github.io/trivy/v0.17.2/air-gap/
    # - trivy -h | grep cache => --cache-dir string          cache directory (default "/.cache/trivy")
    -   tar -xvf trivy-db.tar.gz  # Extract to local where Trivy can find it or set the path in Trivy command
    -   mkdir -p /.cache/trivy/db/
    -   mv .cache/trivy/db/* /.cache/trivy/db/
    - else
    -   cat trivy-db.tar.gz ; echo ""
    -   trivy image --download-db-only
    - fi
  rules:
    - if: $SCHEDULED_JOB == "get-trivy-database"
